version: 1

secrets:
  bitcoin-credentials:
    string_data:
      username: nirvati
      password: {{ derive_entropy(identifier="bitcoin-rpc-password") }}

containers:
  bootstrap:
    image: harbor.nirvati.org/citadel/bitcoin-bootstrap:latest
    job_type: OneTime
    restart: on-failure
    service_account:
      rules:
        - apiGroups: ['']
          resources: ['secrets']
          verbs: ['get', 'create', 'patch']
        - apiGroups: ['arti.nirvati.org']
          resources: ['onionservices']
          verbs: ['get']
    mounts:
      data:
        bitcoin: /bitcoin
    environment:
      APP_NS: {{user}}-bitcoin-core
      USER: {{user}}
      BTC_RPC_USER:
        secret: bitcoin-credentials
        key: username
      BTC_RPC_PASSWORD:
        secret: bitcoin-credentials
        key: password
      BTC_NETWORK: {{ settings.network }}
      {% if settings.prune != "" %}
      BTC_PRUNE: "{{ settings.prune }}"
      {% endif %}

  bitcoin:
    image: lncm/bitcoind:v27.0
    user: "0"
    environment:
      NIRVATI_INITIALIZATION_LOCK:
        secret: nirvati-initialized
        key: dummy
    mounts:
      data:
        bitcoin/data: /root/.bitcoin
    internal_ports:
      8332: 8332
      8333: 8333
      28332: 28332
      28333: 28333
      28334: 28334
      28335: 28335
    public_ports:
      8333: 8333
  gateway:
    image: harbor.nirvati.org/citadel/bitcoin-rpc-proxy:latest
    command: /bitcoin-rpc-proxy /config/accounts.json
    environment:
      BITCOIN_RPC_TARGET: bitcoin.bitcoin-core.{{ user }}.nirvati:8332
      BITCOIN_RPC_USER:
        secret: bitcoin-credentials
        key: username
      BITCOIN_RPC_PASSWORD:
        secret: bitcoin-credentials
        key: password
    internal_ports:
      8332: 8332
    mounts:
      data:
        config/data: /config
  plugin:
    image: harbor.nirvati.org/nirvati/nirvati-plugin-bitcoin:master
    mounts:
      data:
        config/data: /data
    environment:
      PW_SEED: {{ derive_entropy(identifier="bitcoin-pw-seed") }}
      BTC_NETWORK: {{ settings.network }}
      RUST_LOG: debug
    plugins:
      info:
        display_name: Bitcoin Core Integration
        type: context
        port: 50051

tor:
  onion-service:
    rpc:
      target_svc: rpc-proxy
      ports:
        8333: 8333
    p2p:
      target_svc: bitcoin
      ports:
        8332: 8332
